<script>
  // Import
  import { axisLeft, axisBottom } from 'd3-axis';
  import { scaleLinear, scaleBand } from 'd3-scale';
  import { extent } from 'd3-array';
  import { select } from 'd3-selection';
  
  // Dimensions
  const width = 600;
  const height = 300;
  const margin = { top: 10, right: 10, bottom: 30, left: 60 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;

  // Array
  const data = [
    { service: "Netflix", viewers: 2.9 },
    { service: "Amazon Prime Video", viewers: 1.3 },
    { service: "Disney+", viewers: 2.1 },
    { service: "Hulu", viewers: 0.9 },
    { service: "Apple TV", viewers: 1.1 },
    { service: "Rakuten", viewers: 0.4 }
  ];

  // Scales
  const scaleX = scaleBand().domain(data.map(item => item.service)).range([0, innerWidth]).padding(0.2);
  const scaleY = scaleLinear().domain([3, 0]).range([0, innerHeight]);

  // Axis
  const axisX = axisBottom(scaleX);
  const axisY = axisLeft(scaleY);

  function aX(x) {
    axisX(select(x));
  }

  function aY(y) {
    axisY(select(y));
  }

</script>

<!-- setting a viewBox and max-width allows the SVG to shrink but not grow! -->
<svg viewbox="0 0 {width} {height}" style="max-width: {width}px">
  <g transform={`translate(${margin.left},${margin.top})`}>
    <!--  -->
    {#each data as item}
      <rect x={scaleX(item.service)} y={scaleY(item.viewers)}
            width={scaleX.bandwidth()} height = {innerHeight - scaleY(item.viewers)} fill="teal"/>
    {/each}
  </g>
  <g transform="translate({margin.left}, {innerHeight + margin.top})" use:aX></g>
  <g transform="translate({margin.left}, {margin.top})" use:aY>
    <text x={-margin.left/2.5} y=0% fill="currentcolor"> Viewers </text>
  </g>
</svg>
